#!/bin/bash

WAPT_ARCH="arm"
DEBIAN_ARCH="armhf"
RUST_ARCH="armv7"
PYTHON_ARCH="armv7l"


set -e
cd /root
apt-get install patchelf pkg-config build-essential zip unzip -y

# install libpq-dev for psycopg2, currently python install is missing pg_config script to avoid installing this librarie, python-relocatable should be patched to include this file 
apt-get install libpq-dev -y

mount -t proc proc /proc
mkdir /opt/wapt

tar -zxvf /root/python39-linux.tar.gz -C /opt/wapt/

tar -xvf /root/rust-1.80.0.tar.xz 

/root/rust-1.80.0-*/install.sh --prefix=/opt/rust --components=rustc,cargo,rust-std-armv7-unknown-linux-gnueabihf

export PATH=$PATH:/opt/wapt/bin:/opt/rust/bin
rm -Rf /root/.cache/pip/

PKG_CONFIG_PATH=/opt/wapt/lib/pkgconfig/ LANG=C LDFLAGS="-Wl,-rpath,/opt/wapt/lib/,-L/opt/wapt/lib" CFLAGS="-I/opt/wapt/include" CPPFLAGS="-I/opt/wapt/include/" /opt/wapt/bin/python3 -m pip wheel --no-binary :all: -r /root/requirements-agent.txt
PKG_CONFIG_PATH=/opt/wapt/lib/pkgconfig/ LANG=C LDFLAGS="-Wl,-rpath,/opt/wapt/lib/,-L/opt/wapt/lib" CFLAGS="-I/opt/wapt/include" CPPFLAGS="-I/opt/wapt/include/" /opt/wapt/bin/python3 -m pip wheel --no-binary :all: -r /root/requirements-server.txt
PKG_CONFIG_PATH=/opt/wapt/lib/pkgconfig/ LANG=C LDFLAGS="-Wl,-rpath,/opt/wapt/lib/,-L/opt/wapt/lib" CFLAGS="-I/opt/wapt/include" CPPFLAGS="-I/opt/wapt/include/" /opt/wapt/bin/python3 -m pip wheel --no-binary :all: -r /root/requirements-buildlib.txt


#reste a patcher les rpath des librairies qui ne l'on pas été
unzip  cryptography-43.0.0-cp37-abi3-linux_*.whl cryptography/hazmat/bindings/_rust.abi3.so 
patchelf   --set-rpath  /opt/wapt/lib cryptography/hazmat/bindings/_rust.abi3.so
zip -ur cryptography-43.0.0-cp37-abi3-linux_*.whl cryptography/hazmat/bindings/_rust.abi3.so

mkdir /root/wheels/
mv /root/*.whl /root/wheels/
